Index: palm/trunk/SOURCE/check_open.f90
===================================================================
--- palm/trunk/SOURCE/check_open.f90	(revision 3704)
+++ palm/trunk/SOURCE/check_open.f90	(revision 3705)
@@ -20,9 +20,12 @@
 ! Current revisions:
 ! -----------------
-! Open binary files for virtual measurements
+! 
 ! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+! Open binary files for virtual measurements
+! 
+! 3704 2019-01-29 19:51:41Z suehring
 ! Open files for surface data
 ! 
Index: palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- palm/trunk/SOURCE/check_parameters.f90	(revision 3704)
+++ palm/trunk/SOURCE/check_parameters.f90	(revision 3705)
@@ -20,9 +20,12 @@
 ! Current revisions:
 ! -----------------
-! bugfix: renamed thetav_t to vtheta_t
+! 
 ! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+! bugfix: renamed thetav_t to vtheta_t
+! 
+! 3702 2019-01-28 13:19:30Z gronemeier
 ! most_method removed
 ! 
Index: palm/trunk/SOURCE/module_interface.f90
===================================================================
--- palm/trunk/SOURCE/module_interface.f90	(revision 3704)
+++ palm/trunk/SOURCE/module_interface.f90	(revision 3705)
@@ -20,9 +20,12 @@
 ! Current revisions:
 ! -----------------
-! Add last_actions for virtual measurements
+! 
 ! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+! Add last_actions for virtual measurements
+! 
+! 3704 2019-01-29 19:51:41Z suehring
 ! Some interface calls moved to module_interface + cleanup
 ! 
Index: palm/trunk/SOURCE/nesting_offl_mod.f90
===================================================================
--- palm/trunk/SOURCE/nesting_offl_mod.f90	(revision 3704)
+++ palm/trunk/SOURCE/nesting_offl_mod.f90	(revision 3705)
@@ -20,9 +20,12 @@
 ! Current revisions:
 ! ------------------
-! Formatting adjustments
+! 
 ! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+! Formatting adjustments
+! 
+! 3704 2019-01-29 19:51:41Z suehring
 ! Check implemented for offline nesting in child domain 
 ! 
Index: palm/trunk/SOURCE/netcdf_data_input_mod.f90
===================================================================
--- palm/trunk/SOURCE/netcdf_data_input_mod.f90	(revision 3704)
+++ palm/trunk/SOURCE/netcdf_data_input_mod.f90	(revision 3705)
@@ -20,9 +20,12 @@
 ! Current revisions:
 ! -----------------
-! Interface for attribute input of 8-bit and 32-bit integer 
+! 
 ! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+! Interface for attribute input of 8-bit and 32-bit integer 
+! 
+! 3704 2019-01-29 19:51:41Z suehring
 ! unused variables removed
 ! 
Index: palm/trunk/SOURCE/radiation_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/radiation_model_mod.f90	(revision 3704)
+++ palm/trunk/SOURCE/radiation_model_mod.f90	(revision 3705)
@@ -23,9 +23,12 @@
 ! Current revisions:
 ! ------------------
-! Make variables that are sampled in virtual measurement module public 
+! 
 ! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+! Make variables that are sampled in virtual measurement module public 
+! 
+! 3704 2019-01-29 19:51:41Z suehring
 ! Some interface calls moved to module_interface + cleanup
 ! 
Index: palm/trunk/SOURCE/time_integration.f90
===================================================================
--- palm/trunk/SOURCE/time_integration.f90	(revision 3704)
+++ palm/trunk/SOURCE/time_integration.f90	(revision 3705)
@@ -20,9 +20,12 @@
 ! Current revisions:
 ! ------------------
-! Data output for virtual measurements added
+! 
 ! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+! Data output for virtual measurements added
+! 
+! 3704 2019-01-29 19:51:41Z suehring
 ! Rename subroutines for surface-data output
 ! 
Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 3704)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 3705)
@@ -23,9 +23,12 @@
 ! Current revisions:
 ! ------------------
-! make nzb_wall public, required for virtual-measurements
+! 
 ! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+! make nzb_wall public, required for virtual-measurements
+! 
+! 3704 2019-01-29 19:51:41Z suehring
 ! Some interface calls moved to module_interface + cleanup
 ! 
Index: palm/trunk/SOURCE/virtual_measurement_mod.f90
===================================================================
--- palm/trunk/SOURCE/virtual_measurement_mod.f90	(revision 3704)
+++ palm/trunk/SOURCE/virtual_measurement_mod.f90	(revision 3705)
@@ -20,11 +20,14 @@
 ! Current revisions:
 ! -----------------
+! 
+! 
+! Former revisions:
+! -----------------
+! $Id$
 ! - initialization revised
 ! - binary data output
 ! - list of allowed variables extended
 ! 
-! Former revisions:
-! -----------------
-! $Id$
+! 3704 2019-01-29 19:51:41Z suehring
 ! Sampling of variables
 ! 