Index: palm/trunk/SOURCE/biometeorology_mod.f90
===================================================================
--- palm/trunk/SOURCE/biometeorology_mod.f90	(revision 3710)
+++ palm/trunk/SOURCE/biometeorology_mod.f90	(revision 3711)
@@ -27,4 +27,7 @@
 ! -----------------
 ! $Id$
+! Introduced interface routine bio_init_checks + small error message changes
+! 
+! 3693 2019-01-23 15:20:53Z dom_dwd_user
 ! Added usage of time_averaged mean radiant temperature, together with calculation, 
 ! grid and restart routines. General cleanup and commenting.
@@ -245,5 +248,5 @@
     bio_check_parameters, bio_data_output_3d, bio_data_output_2d,              &
     bio_define_netcdf_grid, bio_get_thermal_index_input_ij, bio_header,        &
-    bio_init, bio_parin, bio_perct, bio_perct_av, bio_pet,                     &
+    bio_init, bio_init_checks, bio_parin, bio_perct, bio_perct_av, bio_pet,    &
     bio_pet_av, bio_utci, bio_utci_av, thermal_comfort, time_bio_results,      &
     bio_nmrtbl, bio_wrd_local, bio_rrd_local, bio_wrd_global, bio_rrd_global
@@ -314,4 +317,9 @@
        MODULE PROCEDURE bio_init
     END INTERFACE bio_init
+!
+!-- Initialization checks
+    INTERFACE bio_init_checks
+       MODULE PROCEDURE bio_init_checks
+    END INTERFACE bio_init_checks
 !
 !-- Reading of NAMELIST parameters
@@ -816,5 +824,5 @@
                            'air humidity information, but humidity module ' // &
                            'is disabled!'
-          CALL message( 'check_parameters', 'PA0561', 0, 0, 0, 6, 0 )
+          CALL message( 'bio_check_parameters', 'PA0561', 1, 2, 0, 6, 0 )
        ENDIF
 
@@ -1136,7 +1144,4 @@
  SUBROUTINE bio_init
 
-    USE control_parameters,                                                    &
-        ONLY: message_string
-
     USE netcdf_data_input_mod,                                                 &
         ONLY:  netcdf_data_input_uvem
@@ -1160,18 +1165,32 @@
     bio_output_height = bio_output_height + bio_cell_level * dz(1)
 
+!
+!-- Init UVEM and load lookup tables
+    IF ( uv_exposure )  CALL netcdf_data_input_uvem
+    
+    CALL location_message( 'finished', .TRUE. )
+
+ END SUBROUTINE bio_init
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Checks done after the Initialization
+!------------------------------------------------------------------------------!
+ SUBROUTINE bio_init_checks
+
+    USE control_parameters,                                                    &
+        ONLY: message_string
+
     IF ( .NOT. radiation_interactions ) THEN
        message_string = 'The mrt calculation requires ' //                     &
                         'enabled radiation_interactions but it ' //            &
                         'is disabled!'
-       CALL message( 'check_parameters', 'PAHU03', 0, 0, -1, 6, 0 )
-    ENDIF
-
-!
-!-- Init UVEM and load lookup tables
-    IF ( uv_exposure )  CALL netcdf_data_input_uvem
-    
-    CALL location_message( 'finished', .TRUE. )
-
- END SUBROUTINE bio_init
+       CALL message( 'bio_init_checks', 'PAHU03', 1, 2, 0, 6, 0 )
+    ENDIF
+
+
+ END SUBROUTINE bio_init_checks
 
 
Index: palm/trunk/SOURCE/init_3d_model.f90
===================================================================
--- palm/trunk/SOURCE/init_3d_model.f90	(revision 3710)
+++ palm/trunk/SOURCE/init_3d_model.f90	(revision 3711)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Introduced module_interface_init_checks for post-init checks in modules
+! 
+! 3700 2019-01-26 17:03:42Z knoop
 ! Some interface calls moved to module_interface + cleanup
 ! 
@@ -611,5 +614,7 @@
 
     USE module_interface,                                                      &
-        ONLY:  module_interface_init_arrays, module_interface_init
+        ONLY:  module_interface_init_arrays,                                   &
+               module_interface_init,                                          &
+               module_interface_init_checks
 
     USE multi_agent_system_mod,                                                &
@@ -2245,4 +2250,7 @@
 !-- Initialize the ws-scheme.    
     IF ( ws_scheme_sca .OR. ws_scheme_mom )  CALL ws_init
+!
+!-- Perform post-initializing checks for all other modules
+    CALL module_interface_init_checks
 
 !
Index: palm/trunk/SOURCE/module_interface.f90
===================================================================
--- palm/trunk/SOURCE/module_interface.f90	(revision 3710)
+++ palm/trunk/SOURCE/module_interface.f90	(revision 3711)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Introduced module_interface_init_checks for post-init checks
+! 
+! 3705 2019-01-29 19:56:39Z suehring
 ! Add last_actions for virtual measurements
 ! 
@@ -87,4 +90,5 @@
               bio_check_data_output,                                           &
               bio_init,                                                        &
+              bio_init_checks,                                                 &
               bio_header,                                                      &
               bio_3d_data_averaging,                                           &
@@ -321,4 +325,5 @@
       module_interface_init_arrays,                                            &
       module_interface_init,                                                   &
+      module_interface_init_checks,                                            &
       module_interface_header,                                                 &
       module_interface_actions,                                                &
@@ -370,4 +375,8 @@
       MODULE PROCEDURE module_interface_init
    END INTERFACE module_interface_init
+
+   INTERFACE module_interface_init_checks
+      MODULE PROCEDURE module_interface_init_checks
+   END INTERFACE module_interface_init_checks
 
    INTERFACE module_interface_header
@@ -748,4 +757,18 @@
 ! Description:
 ! ------------
+!> Perform module-specific post-initialization checks
+!------------------------------------------------------------------------------!
+SUBROUTINE module_interface_init_checks
+
+
+   IF ( biometeorology      )  CALL bio_init_checks
+
+
+END SUBROUTINE module_interface_init_checks
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
 !> Gather module-specific header output
 !------------------------------------------------------------------------------!