Index: /palm/trunk/UTIL/inifor/Makefile
===================================================================
--- /palm/trunk/UTIL/inifor/Makefile	(revision 3715)
+++ /palm/trunk/UTIL/inifor/Makefile	(revision 3716)
@@ -25,4 +25,8 @@
 # -----------------
 # $Id$
+# Added __netcdf preprocessor flag
+# 
+# 
+# 3447 2018-10-29 15:52:54Z eckhard
 # Renamed source files for compatibilty with PALM build system 
 # 
@@ -64,5 +68,5 @@
 		  -Wline-truncation -fbacktrace -fcheck=all -pedantic \
 		  -ffpe-trap=invalid,zero,underflow,overflow
-FFLAGS  = -fdefault-real-8 -Og -g $(WRNGS) -cpp -D__netcdf4
+FFLAGS  = -fdefault-real-8 -Og -g $(WRNGS) -cpp -D__netcdf4 -D__netcdf
 INCLUDE = -I/home/ekadasch/local/include
 LIBRARY = -L/home/ekadasch/local/lib64 -lnetcdff
Index: /palm/trunk/UTIL/inifor/Makefile.gnu
===================================================================
--- /palm/trunk/UTIL/inifor/Makefile.gnu	(revision 3715)
+++ /palm/trunk/UTIL/inifor/Makefile.gnu	(revision 3716)
@@ -25,4 +25,8 @@
 # -----------------
 # $Id$
+# Added __netcdf preprocessor flag
+# 
+# 
+# 3447 2018-10-29 15:52:54Z eckhard
 # Renamed source files for compatibilty with PALM build system 
 # 
@@ -65,5 +69,5 @@
 		  -Wline-truncation -fbacktrace -fcheck=all -pedantic \
 		  -ffpe-trap=invalid,zero,underflow,overflow
-FFLAGS  = -fdefault-real-8 -Og -g $(WRNGS) -cpp -D__netcdf4
+FFLAGS  = -fdefault-real-8 -Og -g $(WRNGS) -cpp -D__netcdf4 -D__netcdf
 INCLUDE = -I/home/ekadasch/local/include
 LIBRARY = -L/home/ekadasch/local/lib64 -lnetcdff
Index: /palm/trunk/UTIL/inifor/Makefile.ifort
===================================================================
--- /palm/trunk/UTIL/inifor/Makefile.ifort	(revision 3715)
+++ /palm/trunk/UTIL/inifor/Makefile.ifort	(revision 3716)
@@ -25,4 +25,8 @@
 # -----------------
 # $Id$
+# Added __netcdf preprocessor flag
+# 
+# 
+# 3447 2018-10-29 15:52:54Z eckhard
 # Renamed source files for compatibilty with PALM build system 
 # 
@@ -62,5 +66,5 @@
 
 FC      = ifort
-FFLAGS  = -g -real-size 64 -no-wrap-margin -cpp -D__netcdf4
+FFLAGS  = -g -real-size 64 -no-wrap-margin -cpp -D__netcdf4 -D__netcdf
 INCLUDE = -I/usr/local/pkg/netcdf/4.3.2/include
 LIBRARY = -L/usr/local/pkg/netcdf/4.3.2/lib -lnetcdff
Index: /palm/trunk/UTIL/inifor/src/inifor_defs.f90
===================================================================
--- /palm/trunk/UTIL/inifor/src/inifor_defs.f90	(revision 3715)
+++ /palm/trunk/UTIL/inifor/src/inifor_defs.f90	(revision 3716)
@@ -132,5 +132,5 @@
  INTEGER, PARAMETER          ::  FORCING_STEP = 1             !< Number of hours between forcing time steps [h]
  REAL(dp), PARAMETER         ::  NUDGING_TAU = 21600.0_dp     !< Nudging relaxation time scale [s]
- CHARACTER(LEN=*), PARAMETER ::  VERSION = '1.4.4'            !< INIFOR version number
+ CHARACTER(LEN=*), PARAMETER ::  VERSION = '1.4.5'            !< INIFOR version number
  CHARACTER(LEN=*), PARAMETER ::  COPYRIGHT = 'Copyright 2017-2018 Leibniz Universitaet Hannover' // &
      ACHAR( 10 ) // ' Copyright 2017-2018 Deutscher Wetterdienst Offenbach' !< Copyright notice
Index: /palm/trunk/UTIL/inifor/src/inifor_grid.f90
===================================================================
--- /palm/trunk/UTIL/inifor/src/inifor_grid.f90	(revision 3715)
+++ /palm/trunk/UTIL/inifor/src/inifor_grid.f90	(revision 3716)
@@ -26,4 +26,8 @@
 ! -----------------
 ! $Id$
+! Removed dependency on soilmoisture input files
+! 
+! 
+! 3680 2019-01-18 14:54:12Z knoop
 ! bugfix: Avoid empty averaging regions for small PALM domains
 ! change: moved get_input_file_list() to io module
@@ -471,5 +475,5 @@
        CALL get_input_file_list(                                               &
           cfg % start_date, start_hour_soilmoisture, end_hour_soilmoisture, step_hour, &
-          cfg % input_path, soilmoisture_prefix, soilmoisture_suffix, soil_moisture_files)
+          cfg % input_path, soilmoisture_prefix, soilmoisture_suffix, soil_moisture_files, nocheck=.TRUE.)
 
 !
@@ -2196,4 +2200,5 @@
           kind = 'surface'                                                     &
        )
+       io_group_list(12) % to_be_processed = .FALSE.
 !
 !--    incoming diffusive sw flux
Index: /palm/trunk/UTIL/inifor/src/inifor_io.f90
===================================================================
--- /palm/trunk/UTIL/inifor/src/inifor_io.f90	(revision 3715)
+++ /palm/trunk/UTIL/inifor/src/inifor_io.f90	(revision 3716)
@@ -26,4 +26,8 @@
 ! -----------------
 ! $Id$
+! Removed dependency on soilmoisture input files
+! 
+! 
+! 3680 2019-01-18 14:54:12Z knoop
 ! Moved get_input_file_list() here from grid module, added check for presence of
 !    input files
@@ -576,5 +580,5 @@
    SUBROUTINE get_input_file_list( start_date_string, start_hour, end_hour,    &
                                    step_hour, input_path, prefix, suffix,      &
-                                   file_list )
+                                   file_list, nocheck )
 
       CHARACTER (LEN=DATE), INTENT(IN) ::  start_date_string
@@ -582,8 +586,10 @@
       INTEGER,              INTENT(IN) ::  start_hour, end_hour, step_hour
       CHARACTER(LEN=*), ALLOCATABLE, INTENT(INOUT) ::  file_list(:)
+      LOGICAL, OPTIONAL, INTENT(IN)    ::  nocheck
 
       INTEGER             ::  number_of_intervals, hour, i
       CHARACTER(LEN=DATE) ::  date_string
       CHARACTER(LEN=PATH) ::  file_name
+      LOGICAL             ::  check_files
 
       CALL get_datetime_file_list( start_date_string, start_hour, end_hour,    &
@@ -591,10 +597,19 @@
                                    file_list )
 
-      tip = "Please check if you specified the correct file prefix " //        &
-            "using the options --input-prefix, --flow-prefix, etc."
-
-      DO i = 1, SIZE(file_list)
-          CALL verify_file(file_list(i), 'input', tip)
-      END DO
+      check_files = .TRUE.
+      IF ( PRESENT ( nocheck ) )  THEN
+         IF ( nocheck )  check_files = .FALSE.
+      END IF
+
+      IF ( check_files )  THEN
+
+         tip = "Please check if you specified the correct file prefix " //     &
+               "using the options --input-prefix, --flow-prefix, etc."
+
+         DO i = 1, SIZE(file_list)
+             CALL verify_file(file_list(i), 'input', tip)
+         END DO
+
+      END IF
 
    END SUBROUTINE get_input_file_list
Index: /palm/trunk/UTIL/inifor/src/inifor_transform.f90
===================================================================
--- /palm/trunk/UTIL/inifor/src/inifor_transform.f90	(revision 3715)
+++ /palm/trunk/UTIL/inifor/src/inifor_transform.f90	(revision 3716)
@@ -26,4 +26,8 @@
 ! -----------------
 ! $Id$
+! Include out-of-bounds error message in log 
+! 
+! 
+! 3680 2019-01-18 14:54:12Z knoop
 ! Check if set of averaging columns is empty
 ! 
@@ -777,11 +781,16 @@
           latpos = (palm_clat(i,j) - lat0) * cosmo_dyi
 
-          IF (lonpos < 0.0 .OR. latpos < 0.0)  THEN
-             PRINT *, " Error while finding neighbours: lonpos or latpos out of bounds!"
-             PRINT *, "     (i,j) = (", i, ",",j,")"
-             PRINT *, "      lonpos ", lonpos*TO_DEGREES, ", latpos ", latpos*TO_DEGREES
-             PRINT *, "        lon0 ", lon0  *TO_DEGREES,   ", lat0   ", lat0*TO_DEGREES
-             PRINT *, "    PALM lon ", palm_clon(i,j)*TO_DEGREES,   ", PALM lat ",palm_clat(i,j)*TO_DEGREES
-             STOP
+          IF (lonpos < 0.0_dp .OR. latpos < 0.0_dp)  THEN
+             message = "lonpos or latpos out of bounds " //                    &
+                "while finding interpolation neighbours!" // NEW_LINE(' ') //  &
+                "          (i,j) = (" //                                       &
+                TRIM(str(i)) // ", " // TRIM(str(j)) // ")" // NEW_LINE(' ') //&
+                "          lonpos " // TRIM(real_to_str(lonpos*TO_DEGREES)) // &
+                ", latpos " // TRIM(real_to_str(latpos*TO_DEGREES)) // NEW_LINE(' ') // &
+                "          lon0 " // TRIM(real_to_str(lon0  *TO_DEGREES)) //   &
+                ", lat0   " // TRIM(real_to_str(lat0*TO_DEGREES)) // NEW_LINE(' ') // &
+                "          PALM lon " // TRIM(real_to_str(palm_clon(i,j)*TO_DEGREES)) // &
+                ", PALM lat " // TRIM(real_to_str(palm_clat(i,j)*TO_DEGREES))
+             CALL inifor_abort('find_horizontal_neighbours', message)
           END IF
 