Index: /palm/trunk/SOURCE/chemistry_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 3718)
+++ /palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 3719)
@@ -27,4 +27,8 @@
 ! -----------------
 ! $Id$
+! Resolved cpu logpoint overlap with all progn.equations, moved cpu_log call
+! to prognostic_equations for better overview
+! 
+! 3700 2019-01-26 17:03:42Z knoop
 ! Some interface calls moved to module_interface + cleanup
 ! 
@@ -275,7 +279,4 @@
          vl_dim, nvar, nreact,  atol, rtol, nphot, phot_names
 
-    USE cpulog,                                                                                    &
-         ONLY:  cpu_log, log_point
-
     USE chem_modules
 
@@ -2006,12 +2007,12 @@
  SUBROUTINE chem_integrate_ij( i, j )
 
-    USE cpulog,                                                              &
-         ONLY:  cpu_log, log_point
     USE statistics,                                                          &
-         ONLY:  weight_pres
+        ONLY:  weight_pres
+
     USE control_parameters,                                                  &
-         ONLY:  dt_3d, intermediate_timestep_count, time_since_reference_point
+        ONLY:  dt_3d, intermediate_timestep_count, time_since_reference_point
 
     IMPLICIT NONE
+
     INTEGER,INTENT(IN)       :: i
     INTEGER,INTENT(IN)       :: j
@@ -2051,6 +2052,6 @@
     REAL(kind=wp)  :: dt_chem                                             
 
-    CALL cpu_log( log_point(80), '[chem_integrate_ij]', 'start' )
-    !<     set chem_gasphase_on to .FALSE. if you want to skip computation of gas phase chemistry
+!
+!-- Set chem_gasphase_on to .FALSE. if you want to skip computation of gas phase chemistry
     IF (chem_gasphase_on) THEN
        nacc = 0
@@ -2098,6 +2099,4 @@
        cs_time_step = dt_chem
 
-       CALL cpu_log( log_point(81), '{chem_gasphase_integrate}', 'start' )
-
        IF(maxval(rcntrl) > 0.0)   THEN    ! Only if rcntrl is set
           IF( time_since_reference_point <= 2*dt_3d)  THEN
@@ -2113,6 +2112,4 @@
             icntrl_i = icntrl, rcntrl_i = rcntrl_local, xnacc = nacc, xnrej = nrej, istatus=istatus )
 
-       CALL cpu_log( log_point(81), '{chem_gasphase_integrate}', 'stop' )
-
        DO lsp = 1,nspec
           chem_species(lsp)%conc (nzb+1:nzt,j,i) = tmp_conc(:,lsp) * tmp_fact_i(:)
@@ -2121,5 +2118,4 @@
 
     ENDIF
-    CALL cpu_log( log_point(80), '[chem_integrate_ij]', 'stop' )
 
     RETURN
Index: /palm/trunk/SOURCE/disturb_heatflux.f90
===================================================================
--- /palm/trunk/SOURCE/disturb_heatflux.f90	(revision 3718)
+++ /palm/trunk/SOURCE/disturb_heatflux.f90	(revision 3719)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Moved log_points out of subroutine into time_integration for better overview.
+! 
+! 3655 2019-01-07 16:51:22Z knoop
 ! unused variable removed
 ! 
@@ -112,6 +115,4 @@
 
 
-    CALL cpu_log( log_point(23), 'disturb_heatflux', 'start' )
-
 !
 !-- Generate random disturbances and store them. Note, if 
@@ -163,6 +164,4 @@
     ENDIF
 
-    CALL cpu_log( log_point(23), 'disturb_heatflux', 'stop' )
-
 
  END SUBROUTINE disturb_heatflux
Index: /palm/trunk/SOURCE/large_scale_forcing_nudging_mod.f90
===================================================================
--- /palm/trunk/SOURCE/large_scale_forcing_nudging_mod.f90	(revision 3718)
+++ /palm/trunk/SOURCE/large_scale_forcing_nudging_mod.f90	(revision 3719)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Removed USE cpulog (unused)
+! 
+! 3655 2019-01-07 16:51:22Z knoop
 ! unused variables removed
 ! 
@@ -107,7 +110,4 @@
                topography, use_subsidence_tendencies
                
-    USE cpulog,                                                                &
-        ONLY:  cpu_log, log_point
-
     USE grid_variables
 
Index: /palm/trunk/SOURCE/ocean_mod.f90
===================================================================
--- /palm/trunk/SOURCE/ocean_mod.f90	(revision 3718)
+++ /palm/trunk/SOURCE/ocean_mod.f90	(revision 3719)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! Changed log_point to log_point_s, otherwise this overlaps with 
+! 'all progn.equations' cpu measurement.
+! 
+! 3684 2019-01-20 20:20:58Z knoop
 ! nopointer option removed
 ! 
@@ -1492,5 +1496,5 @@
 
     USE cpulog,                                                                &
-        ONLY:  cpu_log, log_point
+        ONLY:  cpu_log, log_point_s
 
     USE diffusion_s_mod,                                                       &
@@ -1529,5 +1533,5 @@
     IF ( salinity )  THEN
 
-       CALL cpu_log( log_point(37), 'sa-equation', 'start' )
+       CALL cpu_log( log_point_s(20), 'sa-equation', 'start' )
 
 !
@@ -1616,5 +1620,5 @@
        ENDIF
 
-       CALL cpu_log( log_point(37), 'sa-equation', 'stop' )
+       CALL cpu_log( log_point_s(20), 'sa-equation', 'stop' )
 
     ENDIF
@@ -1622,7 +1626,7 @@
 !
 !-- Calculate density by the equation of state for seawater
-    CALL cpu_log( log_point(38), 'eqns-seawater', 'start' )
+    CALL cpu_log( log_point_s(21), 'eqns-seawater', 'start' )
     CALL eqn_state_seawater
-    CALL cpu_log( log_point(38), 'eqns-seawater', 'stop' )
+    CALL cpu_log( log_point_s(21), 'eqns-seawater', 'stop' )
 
  END SUBROUTINE ocean_prognostic_equations
Index: /palm/trunk/SOURCE/palm.f90
===================================================================
--- /palm/trunk/SOURCE/palm.f90	(revision 3718)
+++ /palm/trunk/SOURCE/palm.f90	(revision 3719)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Included cpu measurement for wall/soil spinup
+! 
+! 3703 2019-01-29 16:43:53Z knoop
 ! Some interface calls moved to module_interface + cleanup
 ! 
@@ -536,5 +539,7 @@
 !-- surface model)
     IF ( spinup )  THEN
+       CALL cpu_log( log_point(41), 'wall/soil spinup', 'start' )
        CALL time_integration_spinup
+       CALL cpu_log( log_point(41), 'wall/soil spinup', 'stop' )
     ENDIF
 
Index: /palm/trunk/SOURCE/prognostic_equations.f90
===================================================================
--- /palm/trunk/SOURCE/prognostic_equations.f90	(revision 3718)
+++ /palm/trunk/SOURCE/prognostic_equations.f90	(revision 3719)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Cleaned up chemistry cpu measurements
+! 
+! 3684 2019-01-20 20:20:58Z knoop
 ! OpenACC port for SPEC
 ! 
@@ -509,7 +512,5 @@
        lsp_usr = 1
 !
-!--    Chemical reactions
-       CALL cpu_log( log_point(82), '(chem react + exch_h)', 'start' )
-  
+!--    Chemical reactions and deposition
        IF ( chem_gasphase_on ) THEN
 !
@@ -524,7 +525,13 @@
                 IF ( intermediate_timestep_count == 1 .OR.                        &
                      call_chem_at_all_substeps )  THEN
+
+                   CALL cpu_log( log_point_s(19), 'chem.reactions', 'start' )  
                    CALL chem_integrate (i,j)
+                   CALL cpu_log( log_point_s(19), 'chem.reactions', 'stop' )
+
                    IF ( do_depo )  THEN
+                      CALL cpu_log( log_point_s(24), 'chem.deposition', 'start' )
                       CALL chem_depo(i,j)
+                      CALL cpu_log( log_point_s(24), 'chem.deposition', 'stop' )
                    ENDIF
                 ENDIF
@@ -534,5 +541,5 @@
 !
 !--    Loop over chemical species       
-       CALL cpu_log( log_point_s(84), 'chemistry exch-horiz ', 'start' )
+       CALL cpu_log( log_point_s(84), 'chem.exch-horiz', 'start' )
        DO  lsp = 1, nspec
           CALL exchange_horiz( chem_species(lsp)%conc, nbgp )    
@@ -550,7 +557,5 @@
 
        ENDDO
-       CALL cpu_log( log_point_s(84), 'chemistry exch-horiz ', 'stop' )
-     
-       CALL cpu_log( log_point(82), '(chem react + exch_h)', 'stop' )
+       CALL cpu_log( log_point_s(84), 'chem.exch-horiz', 'stop' )
 
     ENDIF       
@@ -2611,5 +2616,5 @@
 !-- Calculate prognostic equation for chemical quantites
     IF ( air_chemistry )  THEN
-       CALL cpu_log( log_point(83), '(chem advec+diff+prog)', 'start' )
+       CALL cpu_log( log_point_s(25), 'chem.advec+diff+prog', 'start' )
 !
 !--    Loop over chemical species
@@ -2622,5 +2627,5 @@
        ENDDO
 
-       CALL cpu_log( log_point(83), '(chem advec+diff+prog)', 'stop' )             
+       CALL cpu_log( log_point_s(25), 'chem.advec+diff+prog', 'stop' )             
     ENDIF   ! Chemicals equations
         
Index: /palm/trunk/SOURCE/synthetic_turbulence_generator_mod.f90
===================================================================
--- /palm/trunk/SOURCE/synthetic_turbulence_generator_mod.f90	(revision 3718)
+++ /palm/trunk/SOURCE/synthetic_turbulence_generator_mod.f90	(revision 3719)
@@ -25,4 +25,9 @@
 ! -----------------
 ! $Id$
+! Removed log_point measurement from stg_init, since this part is counted to
+! log_point(2) 'initialisation' already. Moved other log_points to calls of
+! the subroutines in time_integration for better overview.
+! 
+! 3646 2018-12-28 17:58:49Z kanani
 ! Bugfix: use time_since_reference_point instead of simulated_time (relevant
 ! when using wall/soil spinup)
@@ -182,7 +187,4 @@
                syn_turb_gen
 
-    USE cpulog,                                                                &
-        ONLY:  cpu_log, log_point
-
     USE indices,                                                               &
         ONLY:  nbgp, nzb, nzt, nxl, nxlg, nxr, nxrg, nys, nyn, nyng, nysg
@@ -573,6 +575,4 @@
 #endif
 
-    CALL  cpu_log( log_point(57), 'synthetic_turbulence_gen', 'start' )
-
 #if defined( __parallel )
 !
@@ -885,6 +885,4 @@
     ENDIF
 
-    CALL  cpu_log( log_point(57), 'synthetic_turbulence_gen', 'stop' )
-
  END SUBROUTINE stg_init
 
@@ -1085,5 +1083,4 @@
     REAL(wp) :: volume_flow_l   !< local mass flux through lateral boundary
 
-    CALL  cpu_log( log_point(57), 'synthetic_turbulence_gen', 'start' )
 
 !
@@ -1429,5 +1426,4 @@
     time_stg_call = 0.0_wp
 
-    CALL  cpu_log( log_point(57), 'synthetic_turbulence_gen', 'stop' )
 
  END SUBROUTINE stg_main
@@ -1833,5 +1829,5 @@
     INTEGER(iwp) ::  k
 
-    CALL  cpu_log( log_point(57), 'synthetic_turbulence_gen', 'start' )
+
 !
 !-- Compute mean boundary layer height according to Richardson-Bulk
@@ -1867,5 +1863,4 @@
     time_stg_adjust = 0.0_wp
     
-    CALL  cpu_log( log_point(57), 'synthetic_turbulence_gen', 'stop' )
     
  END SUBROUTINE stg_adjust 
Index: /palm/trunk/SOURCE/time_integration.f90
===================================================================
--- /palm/trunk/SOURCE/time_integration.f90	(revision 3718)
+++ /palm/trunk/SOURCE/time_integration.f90	(revision 3719)
@@ -25,4 +25,12 @@
 ! -----------------
 ! $Id$
+! - removed wind_turbine cpu measurement, since same time is measured inside
+!   wtm_forces subroutine as special measures
+! - moved the numerous vnest cpulog to special measures
+! - extended radiation cpulog over entire radiation part,
+!   moved radiation_interactions cpulog to special measures
+! - moved some cpu_log calls to this routine for better overview
+! 
+! 3705 2019-01-29 19:56:39Z suehring
 ! Data output for virtual measurements added
 ! 
@@ -795,8 +803,8 @@
        IF ( vnested ) THEN
           IF ( .NOT. vnest_init  .AND.  simulated_time >= vnest_start_time )  THEN
-             CALL cpu_log( log_point(80), 'vnest_init', 'start' )
+             CALL cpu_log( log_point_s(22), 'vnest_init', 'start' )
              CALL vnest_init_fine
              vnest_init = .TRUE.
-             CALL cpu_log( log_point(80), 'vnest_init', 'stop' )
+             CALL cpu_log( log_point_s(22), 'vnest_init', 'stop' )
           ENDIF
        ENDIF
@@ -841,13 +849,5 @@
 !
 !--    Calculate forces by wind turbines
-       IF ( wind_turbine )  THEN
-
-          CALL cpu_log( log_point(55), 'wind_turbine', 'start' )
-
-          CALL wtm_forces
-
-          CALL cpu_log( log_point(55), 'wind_turbine', 'stop' )
-
-       ENDIF   
+       IF ( wind_turbine )  CALL wtm_forces  
        
 !
@@ -1049,7 +1049,7 @@
 !--       Vertical nesting: Interpolate fine grid data to the coarse grid
           IF ( vnest_init ) THEN
-             CALL cpu_log( log_point(81), 'vnest_anterpolate', 'start' )
+             CALL cpu_log( log_point_s(37), 'vnest_anterpolate', 'start' )
              CALL vnest_anterpolate
-             CALL cpu_log( log_point(81), 'vnest_anterpolate', 'stop' )
+             CALL cpu_log( log_point_s(37), 'vnest_anterpolate', 'stop' )
           ENDIF
 
@@ -1125,9 +1125,9 @@
 !
 !--       Impose a turbulent inflow using the recycling method
-          IF ( turbulent_inflow )  CALL  inflow_turbulence
+          IF ( turbulent_inflow )  CALL inflow_turbulence
 
 !
 !--       Set values at outflow boundary using the special outflow condition
-          IF ( turbulent_outflow )  CALL  outflow_turbulence
+          IF ( turbulent_outflow )  CALL outflow_turbulence
 
 !
@@ -1170,6 +1170,8 @@
 !--       only once per time step.
           IF ( use_syn_turb_gen  .AND.  time_stg_call >= dt_stg_call  .AND.    &
-             intermediate_timestep_count == intermediate_timestep_count_max )  THEN! &
+             intermediate_timestep_count == intermediate_timestep_count_max )  THEN
+             CALL cpu_log( log_point(57), 'synthetic_turbulence_gen', 'start' )
              CALL stg_main
+             CALL cpu_log( log_point(57), 'synthetic_turbulence_gen', 'stop' )
           ENDIF
 !
@@ -1191,14 +1193,14 @@
                 IF ( coupling_mode == 'vnested_crse' )  CALL pres
 
-                CALL cpu_log( log_point(82), 'vnest_bc', 'start' )
+                CALL cpu_log( log_point_s(30), 'vnest_bc', 'start' )
                 CALL vnest_boundary_conds
-                CALL cpu_log( log_point(82), 'vnest_bc', 'stop' )
+                CALL cpu_log( log_point_s(30), 'vnest_bc', 'stop' )
  
                 IF ( coupling_mode == 'vnested_fine' )  CALL pres
 
 !--             Anterpolate TKE, satisfy Germano Identity
-                CALL cpu_log( log_point(83), 'vnest_anter_e', 'start' )
+                CALL cpu_log( log_point_s(28), 'vnest_anter_e', 'start' )
                 CALL vnest_anterpolate_e
-                CALL cpu_log( log_point(83), 'vnest_anter_e', 'stop' )
+                CALL cpu_log( log_point_s(28), 'vnest_anter_e', 'stop' )
 
              ELSE
@@ -1347,11 +1349,9 @@
                 CALL radiation_control
 
-                CALL cpu_log( log_point(50), 'radiation', 'stop' )
-
                 IF ( ( urban_surface  .OR.  land_surface )  .AND.               &
                      radiation_interactions )  THEN
-                   CALL cpu_log( log_point(75), 'radiation_interaction', 'start' )
+                   CALL cpu_log( log_point_s(75), 'radiation_interaction', 'start' )
                    CALL radiation_interaction
-                   CALL cpu_log( log_point(75), 'radiation_interaction', 'stop' )
+                   CALL cpu_log( log_point_s(75), 'radiation_interaction', 'stop' )
                 ENDIF
     
@@ -1359,4 +1359,6 @@
 !--             Return the current time to its original value
                 time_since_reference_point = time_since_reference_point_save
+
+                CALL cpu_log( log_point(50), 'radiation', 'stop' )
 
              ENDIF
@@ -1477,5 +1479,9 @@
           IF ( parametrize_inflow_turbulence )  THEN
              time_stg_adjust = time_stg_adjust + dt_3d
-             IF ( time_stg_adjust >= dt_stg_adjust )  CALL stg_adjust
+             IF ( time_stg_adjust >= dt_stg_adjust )  THEN
+                CALL cpu_log( log_point(57), 'synthetic_turbulence_gen', 'start' )
+                CALL stg_adjust
+                CALL cpu_log( log_point(57), 'synthetic_turbulence_gen', 'stop' )
+             ENDIF
           ENDIF
           time_stg_call = time_stg_call + dt_3d
@@ -1745,9 +1751,21 @@
 
 !
-!--    If required, set the heat flux for the next time step at a random value
+!--    If required, set the heat flux for the next time step to a random value
        IF ( constant_heatflux  .AND.  random_heatflux )  THEN
-          IF ( surf_def_h(0)%ns >= 1 )  CALL disturb_heatflux( surf_def_h(0) )
-          IF ( surf_lsm_h%ns    >= 1 )  CALL disturb_heatflux( surf_lsm_h    )
-          IF ( surf_usm_h%ns    >= 1 )  CALL disturb_heatflux( surf_usm_h    )
+          IF ( surf_def_h(0)%ns >= 1 )  THEN
+             CALL cpu_log( log_point(23), 'disturb_heatflux', 'start' )
+             CALL disturb_heatflux( surf_def_h(0) )
+             CALL cpu_log( log_point(23), 'disturb_heatflux', 'stop' )
+          ENDIF
+          IF ( surf_lsm_h%ns    >= 1 )  THEN
+             CALL cpu_log( log_point(23), 'disturb_heatflux', 'start' )
+             CALL disturb_heatflux( surf_lsm_h    )
+             CALL cpu_log( log_point(23), 'disturb_heatflux', 'stop' )
+          ENDIF
+          IF ( surf_usm_h%ns    >= 1 )  THEN
+             CALL cpu_log( log_point(23), 'disturb_heatflux', 'start' )
+             CALL disturb_heatflux( surf_usm_h    )
+             CALL cpu_log( log_point(23), 'disturb_heatflux', 'stop' )
+          ENDIF
        ENDIF
 
Index: /palm/trunk/SOURCE/time_integration_spinup.f90
===================================================================
--- /palm/trunk/SOURCE/time_integration_spinup.f90	(revision 3718)
+++ /palm/trunk/SOURCE/time_integration_spinup.f90	(revision 3719)
@@ -25,4 +25,9 @@
 ! -----------------
 ! $Id$
+! Removed log_point(19,54,74,50,75), since they count together with same log
+! points in time_integration, impossible to separate the contributions.
+! Instead, the entire spinup gets an individual log_point in palm.f90
+! 
+! 3655 2019-01-07 16:51:22Z knoop
 ! Removed call to calculation of near air (10 cm) potential temperature (now in
 ! surface layer fluxes)
@@ -360,7 +365,5 @@
 !--          (constant flux) layer are computed
              IF ( constant_flux_layer )  THEN
-                CALL cpu_log( log_point(19), 'surface_layer_fluxes', 'start' )
                 CALL surface_layer_fluxes
-                CALL cpu_log( log_point(19), 'surface_layer_fluxes', 'stop' )
              ENDIF
 
@@ -371,5 +374,4 @@
              IF ( land_surface )  THEN
 
-                CALL cpu_log( log_point(54), 'land_surface', 'start' )
 !
 !--             Call for horizontal upward-facing surfaces
@@ -392,6 +394,5 @@
                 CALL lsm_energy_balance( .FALSE., 3 )
                 CALL lsm_soil_model( .FALSE., 3, calc_soil_moisture_during_spinup )
-                
-                CALL cpu_log( log_point(54), 'land_surface', 'stop' )
+
              ENDIF
 
@@ -400,5 +401,5 @@
 !--          the material heat model
              IF (urban_surface) THEN
-                CALL cpu_log( log_point(74), 'urban_surface', 'start' )
+
                 CALL usm_surface_energy_balance( .TRUE. )
                 IF ( usm_material_model )  THEN
@@ -406,6 +407,5 @@
                    CALL usm_material_heat_model( .TRUE. )
                 ENDIF
-                
-                CALL cpu_log( log_point(74), 'urban_surface', 'stop' )
+
              ENDIF
 
@@ -422,6 +422,4 @@
              THEN
 
-                CALL cpu_log( log_point(50), 'radiation', 'start' )
-
                 IF ( .NOT. force_radiation_call )  THEN
                    time_radiation = time_radiation - dt_3d
@@ -430,10 +428,6 @@
                 CALL radiation_control
 
-                CALL cpu_log( log_point(50), 'radiation', 'stop' )
-
                 IF ( radiation_interactions )  THEN
-                   CALL cpu_log( log_point(75), 'radiation_interaction', 'start' )
                    CALL radiation_interaction
-                   CALL cpu_log( log_point(75), 'radiation_interaction', 'stop' )
                 ENDIF
              ENDIF
Index: /palm/trunk/SOURCE/turbulence_closure_mod.f90
===================================================================
--- /palm/trunk/SOURCE/turbulence_closure_mod.f90	(revision 3718)
+++ /palm/trunk/SOURCE/turbulence_closure_mod.f90	(revision 3719)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! Changed log_point to log_point_s, otherwise this overlaps with 
+! 'all progn.equations' cpu measurement.
+! 
+! 3684 2019-01-20 20:20:58Z knoop
 ! Remove unused variable simulated_time
 ! 
@@ -214,5 +218,5 @@
 
     USE cpulog,                                                                &
-        ONLY:  cpu_log, log_point, log_point_s
+        ONLY:  cpu_log, log_point_s
 
     USE indices,                                                               &
@@ -1945,5 +1949,5 @@
     IF ( .NOT. constant_diffusion )  THEN
 
-       CALL cpu_log( log_point(16), 'tke-equation', 'start' )
+       CALL cpu_log( log_point_s(16), 'tke-equation', 'start' )
 
        sbt = tsc(2)
@@ -2053,5 +2057,5 @@
        ENDIF
 
-       CALL cpu_log( log_point(16), 'tke-equation', 'stop' )
+       CALL cpu_log( log_point_s(16), 'tke-equation', 'stop' )
 
     ENDIF   ! TKE equation
@@ -2061,5 +2065,5 @@
     IF ( rans_tke_e )  THEN
 
-       CALL cpu_log( log_point(33), 'diss-equation', 'start' )
+       CALL cpu_log( log_point_s(33), 'diss-equation', 'start' )
 
        sbt = tsc(2)
@@ -2153,5 +2157,5 @@
        ENDIF
 
-       CALL cpu_log( log_point(33), 'diss-equation', 'stop' )
+       CALL cpu_log( log_point_s(33), 'diss-equation', 'stop' )
 
     ENDIF